100   REM
110   REM           Pocket A/D Converter: Sample Program
120   REM
130   RESOLUTION = 12
140   PV = 0
150   LPT1 = &H3BC : LPT2 = &H378 : LPT3 = &H278
160   LOOPCOUNT = 0
170   PORT = LPT1
180   BOX = 0
190   LOCATE 24, 1 : FOR I = 1 TO 25 : PRINT : NEXT
200   LOCATE 2, 20 : PRINT "Pocket A/D Converter Test Program V1.0";
210   LOCATE 24, 20 : PRINT "   [L]: LPT   [B]: BOXID   [ESC]: QUIT ";
220   LOCATE 7, 28 : PRINT "CHANNEL";
230   LOCATE 7, 45 : PRINT "VALUE";
240   FOR CHANNEL = 0 TO 10
250     LOCATE 8 + CHANNEL, 30 : PRINT USING "##"; CHANNEL + 1;
260     GOSUB 1000
270     LOCATE 8 + CHANNEL, 45 : PRINT USING "####"; AD
280   NEXT
290   LOCATE 19, 30 : PRINT "Ref";
300   CHANNEL = 11 : GOSUB 1000
310   LOCATE 19, 45 : PRINT USING "####"; AD
320   LOCATE 20, 30 : PRINT "Ref-";
330   CHANNEL = 12 : GOSUB 1000
340   LOCATE 20, 45 : PRINT USING "####"; AD
350   LOCATE 21, 30 : PRINT "Ref+";
360   CHANNEL = 13 : GOSUB 1000
370   LOCATE 21, 45 : PRINT USING "####"; AD
380   LOCATE 4, 55
390   IF PORT = LPT1 THEN PRINT "LPT1";
400   IF PORT = LPT2 THEN PRINT "LPT2";
410   IF PORT = LPT3 THEN PRINT "LPT3";
420   LOOPCOUNT = LOOPCOUNT + 1
430   LOCATE 4, 20 : PRINT "LOOP: " ; USING "##########"; LOOPCOUNT;
440   LOCATE 4, 40 : PRINT "BOX:"; BOX
450   A$ = INKEY$
460   IF A$ = "" THEN GOTO 240
470   IF A$ <> "l" AND A$ <> "L" THEN GOTO 520
480   IF PORT = LPT1 THEN PORT = LPT2 : GOTO 240
490   IF PORT = LPT2 THEN PORT = LPT3 : GOTO 240
500   PORT = LPT1
510   GOTO 240
520   IF A$ <> "b" AND A$ <> "B" THEN GOTO 560
530   BOX = BOX + 1
540   IF BOX > 15 THEN BOX = 0
550   GOTO 240
560   IF A$ <> CHR$(27) THEN GOTO 240
999   END
1000  REM      GET A/D VALUE
1010  REM      INPUT :
1020  REM           BOX     : BOX ID
1030  REM           CHANNEL : CHANNEL NUMBER
1040  REM      OUTPUT :
1050  REM           AD : A/D VALUE
1060  REM ===========================================
1070  NEWFLAG = 0
1080  IF BOX = PREVBOX THEN GOTO 1130
1090  PREVBOX = BOX
1100  PV = BOX * 16
1110  OUT PORT, PV
1120  NEWFLAG = 1
1130  IF CHANNEL = PREVCHANNEL THEN GOTO 1170
1140  PREVCHANNEL = CHANNEL
1150  NEWFLAG = 1
1160  IF NEWFLAG = 1 THEN GOSUB 1500
1170  GOSUB 1500
1180  RETURN
1500  FOR I = 1 TO 10
1510    X = INP(PORT + 1) AND 8
1520    IF X > 0 THEN GOTO 1550
1530  NEXT
1540  AD = -1 : RETURN
1550  AD = 0
1560  FOR I = 1 TO RESOLUTION
1570    IF I <= 4 THEN X = 2 ^ (4 - I) ELSE X = 0
1580    X = CHANNEL AND X
1590    IF X > 0 THEN Y = 4 ELSE Y = 0
1600    OUT PORT, PV + Y
1610    AD = AD * 2
1620    X = INP (PORT + 1) AND &H10
1630    IF X > 0 THEN AD = AD + 1
1640    OUT PORT, PV + Y + 2
1650    OUT PORT, PV + Y
1660  NEXT
1670  RETURN
