100   REM
110   REM           Pocket I/O Converter: Sample Program
120   REM
140   PV = 0
150   LPT1 = &H3BC : LPT2 = &H378 : LPT3 = &H278
160   PORT = LPT1
170   BOX = 0
180   FOR COUNT = 0 TO 7
200     GOSUB 1500
210     GOSUB 1000
220     FOR J = 0 TO 7
230       IF (DI AND (2 ^ J)) > 0 THEN PRINT " ON  "; ELSE PRINT " OFF ";
240     NEXT
250     PRINT
260     FOR K = 1 TO 10000 : NEXT
270   NEXT
280     DO = 2 ^ COUNT
999   END
1000  REM      GET I/O VALUE
1010  REM      INPUT :
1020  REM           BOX     : BOX ID
1040  REM      OUTPUT :
1050  REM           DI : DIGITAL INPUT VALUE
1060  REM ===========================================
1070  PV = BOX * 16
1080  OUT PORT, PV
1090  OUT PORT, PV OR &H8
1100  OUT PORT, PV
1110  DI = 0
1120  FOR I = 0 TO 7
1130    X = INP (PORT + 1) AND &H10
1140    IF X > 0 THEN DI = DI OR (2 ^ (7 - I))
1150    OUT PORT, PV OR &H2
1160    OUT PORT, PV
1170  NEXT
1180  RETURN
1500  REM      SET I/O VALUE
1510  REM      INPUT :
1520  REM           BOX     : BOX ID
1540  REM      OUTPUT :
1550  REM           DO : DIGITAL OUTPUT VALUE
1560  REM ===========================================
1570  PV = BOX * 16 + &H1
1580  OUT PORT, PV
1590  FOR I = 0 TO 7
1600    IF DO AND (2 ^ (7 - I)) > 0 THEN PV = PV OR &H4 ELSE PV = PV AND &HFB
1610    OUT PORT, PV
1620    OUT PORT, PV OR &H2
1630    OUT PORT, PV
1640  NEXT
1650  OUT PORT, PV OR &H8
1660  OUT PORT, PV
1670  RETURN
